/**
 * created by tony.guo@uxin.com
 * version v1.0
 * time 2017年03月22日16:57:17
 * @type {{}}
 */
var upConfigText = {};

upConfigText.FILES_ON_DEVICE = '您设备上的文件列表';
upConfigText.FILENAME = '文件名';
upConfigText.FILE_SIZE = '大小';
upConfigText.FILE_OPER = '操作';
upConfigText.CONFIRM_DELETE_BOOK = '是否删除音频？';
upConfigText.DOWNLOAD_FILE = '下载文件';
upConfigText.DELETE_FILE = '删除文件';
upConfigText.USE_ONE_BROWSER = '无法上传文件，请勿使用多个浏览器窗口同时上传。';
upConfigText.UPLOAD_FAILED = '上传失败，请重新打开wifi音频上传服务并刷新此页重新上传。';
upConfigText.UNSUPPORTED_FILE_TYPE = '请选择MP3或M4A音频文件。';
upConfigText.FILE_IN_QUEUE = '文件已经在上传列队中。';
upConfigText.FILE_EXISTS = '文件已存在，请先删除再重新上传。';
upConfigText.YOU_CHOOSE = '您选择了';
upConfigText.CHOSEN_FILE_COUNT = '个文件，只能上传';
upConfigText.VALID_CHOSEN_FILE_COUNT = '个文件。\n请选择MP3或M4A文件，文件名不能重复。';
upConfigText.CANCEL = '取消';
upConfigText.CANNOT_CONNECT_SERVER = '无法连接wifi音频上传服务器，请重新打开wifi音频上传服务并刷新此页后重新上传。';
upConfigText.DRAG_TO_HERE = "拖拽到此处上传";
upConfigText.SELECT_BUTTON_LABLE1 = "选择文件";
upConfigText.SELECT_BUTTON_LABLE2 = "可同时上传多个文件";
upConfigText.SELECT_BUTTON_LABLE = "选择文件";
upConfigText.WIFI_AVAILABLE = "wifi连接已启用";
$(function() {
    if(!jQuery.handleError){
        jQuery.handleError = function( s, xhr, status, e )      {
            // If a local callback was specified, fire it
            if ( s.error ) {
                s.error.call( s.context || s, xhr, status, e );
            }

            // Fire the global callback
            if ( s.global ) {
                (s.context ? jQuery(s.context) : jQuery.event).trigger( "ajaxError", [xhr, s, e] );
            }
        };
    }

	var files = [];

	var html5Uploader = null;
	var items = {};
    var uploading = {};


	function deleteAudio() {
		var fileObj=$(".file.checked"),
			fileObjLen=fileObj.length;
		if(fileObjLen<1){
			return alert("您还未勾选要删除的音频");
		}
		if (!confirm(upConfigText.CONFIRM_DELETE_BOOK)) {
			return;
		}
		showStatusMsg("正在删除",'loading');
		var fileNameArr=[];
        var uploader = getHtml5Uploader();
		for(var i=0;i<fileObjLen;i++){
			var fileName = unescape(fileObj.eq(i).find(".filename").attr("filename")) ||'';
            uploadingItem = uploading[fileName];
            if (uploadingItem) {
                uploader.abort(uploadingItem);
            }
            fileNameArr.push('"'+fileName+'"');
		}
		var deleteUrl = "/del";
		$.get(deleteUrl, {'filename':encodeURI('['+fileNameArr.toString()+']')}, function() {
			showStatusMsg("已删除",'success');
			setTimeout(function() {
				fileObj.remove();
			}, 300);
			setTimeout(function() {
				hideMsg();
			}, 2000);
		});
	}


	function loadFileList() {
		var now = new Date();
		$(".delBtn").click(deleteAudio);
		var url = "/get_list?";
		$.getJSON(url + now.getTime(), function(data) {
			files = data;
			fillFilesContainer();
		});
		$("body").on("click",".file .check",function(){
			var $this=$(this);
			if($this.hasClass("on")){
				$this.removeClass("on");
				$this.closest(".file").removeClass("checked");
			}else{
				$this.addClass("on");
				$this.closest(".file").addClass("checked");
			}
		});
		$(".table_header .check").on("click",function(){
			var $this=$(this);
			if($this.hasClass("on")){
				$this.removeClass("on");
				$(".file").removeClass("checked");
				$(".file").find(".check").removeClass("on");
			}else{
				$this.addClass("on");
				$(".file").find(".check").addClass("on");
				$(".file").addClass("checked");
			}
		});
	}

	/*检查文件名*/
	function checkFileName(fileName) {
		if (!fileName || !fileName.toLowerCase().match('(mp3|m4a)$')) {
			return upConfigText.UNSUPPORTED_FILE_TYPE;
		}

		var arr = fileName.split("\\");
		fileName = arr[arr.length - 1];

		var hasFile = false;
		var existFile = $("#fileList .file [filename='" + escape(fileName) + "']");
		if (existFile.length > 0) {
            $(this).val("");
			if (existFile.parent().hasClass('progress_wrapper')) {
				return upConfigText.FILE_IN_QUEUE;
			} else {
				return upConfigText.FILE_EXISTS;
			}
		}
		return null;
	}

	function getFileSize(fileSize){
		while (fileSize > 1024) {
			fileSize /= 1024;
		}
		return Math.ceil(fileSize);
	}

	//格式化时间戳
	function formatDate(val) {
		var datetime = new Date(val);
		var year=datetime.getFullYear();
		var month=datetime.getUTCMonth()+1;
		var date=datetime.getDate();
		var hour=datetime.getHours();
		var minute=datetime.getMinutes();
		var second=datetime.getSeconds();
		return year+"-"+month+"-"+date+" "+hour+":"+minute+":"+second;
	}

	function add0(m){return m<10?'0'+m:m }

	function format_times(val)
	{
		var time = new Date(val);
		var y = time.getFullYear();
		var m = time.getMonth()+1;
		var d = time.getDate();
		var h = time.getHours()+1;
		var mm = time.getMinutes()+1;
		var s = time.getSeconds()+1;
		return y+'-'+add0(m)+'-'+add0(d)+' '+add0(h)+':'+add0(mm)+':'+add0(s);
	}
	function deleteAudio() {
		var fileObj=$(".check-box.on"),
			fileObjLen=fileObj.length;
		if(fileObjLen<1){
			return alert("您还未勾选要删除的音频");
		}
		if (!confirm(upConfigText.CONFIRM_DELETE_BOOK)) {
			return;
		}
		// showStatusMsg("正在删除",'loading');

		var fileNameArr=[];
		var uploader = getHtml5Uploader();
		var join_filename_str = '';

		for(var i=0;i<fileObjLen;i++){
			var fileName = unescape(fileObj.eq(i).parent().attr("filename")) || '';
			console.log(fileName);

			if(fileName != 'undefined'){
				join_filename_str += fileName + '|';
			}


			/*
			uploadingItem = uploading[fileName];
			if (uploadingItem) {
				uploader.abort(uploadingItem);
			}
			fileNameArr.push('"'+fileName+'"');*/
		}

		join_filename_str=join_filename_str.substring(0,join_filename_str.length-1);

		console.log(join_filename_str);
		$.post('/del',{
			filename_str:encodeURI(join_filename_str),
		},function(res){
			location.reload();
		});
		/*
		var deleteUrl = "/del";
		$.get(deleteUrl, {'filename':encodeURI('['+fileNameArr.toString()+']')}, function() {
			showStatusMsg("已删除",'success');
			setTimeout(function() {
				fileObj.remove();
			}, 300);
			setTimeout(function() {
				hideMsg();
			}, 2000);
		});*/
	}

	function formatFileSize(value) {
	    var multiplyFactor = 0;
	    var tokens = ["bytes","KB","MB","GB","TB"];

	    while (value > 1024) {
	        value /= 1024;
	        multiplyFactor++;
	    }

	    return value.toFixed(1) + " " + tokens[multiplyFactor];
	}
	//控制进度条
	function setProcess(eleProgress){
		var style_width = (eleProgress.width() + 100);
		eleProgress.css('width',style_width);
	}

	function getHtml5Uploader() {
		if (!html5Uploader) {
			switch_check_box(); 	//绑定check_box事件
			html5Uploader = new bitcandies.FileUploader({
				url: 'upload',			//上传路径
				maxconnections: 1,
				fieldname: 'music_files',
				enqueued: function (item) {				//两个文件以上要在这里排队

					var fileName = item.getFilename();
					items[escape(fileName)] = item;

					uploading[escape(fileName)] = item;

					var size = item.getSize();
					var row = $('<li class="item uploading" id="WU_FILE_2"></li>');

					row.append('<div class="progress"> <i style="width:0%;"></i> </div>');
					row.append('<div class="filename" filename="' + escape(fileName) + '"><span class="check-box"></span>' + fileName +'</div>');
					row.append('<div class="filesize">排队中…</div>');
					row.append('<div class="longtime">' + formatFileSize(size) +'</div>');
					$('<div class="operate" style = "color: #3984ff" title="'+upConfigText.CANCEL+'">取消上传</div>')
						.click(cancelUpload)
						.appendTo(row);
					$(".list-sound").prepend(row);
				},
				progress: function (item, loaded, total) {			//上传中

					var fileName = item.getFilename();
					var progress = loaded / total;

					var ele = $(".list .list-sound [filename='" + escape(fileName) + "']");

					var elePrecent = ele.next();

					elePrecent.text("上传中…");

					var eleProgress = ele.prev().children('i');



					var bartimer = setInterval(function(){
						setProcess(eleProgress);
						if(eleProgress.width() > 500){
							// console.log(eleProgress.width());
							clearInterval(bartimer);
						}
					},200);

					if(eleProgress.width() > 100){
						console.log(eleProgress.width());
						clearInterval(bartimer);
					}

				},
				success: function (item,xhr) {
					// var res = JSON.parse(xhr.response);
					var fileName = item.getFilename();
					console.log(fileName);
					var row = $(".list .list-sound [filename='" + escape(fileName) + "']").parent();

					row.removeClass('progress');
					row.find('.progress').remove();
					// row.find('.createTime').text(res.date);
					// row.find('.cancel').remove();
//					row.find('.filesize').html("3:45");
                    row.find('.filesize').remove();
                    row.find('.operate').css("color","#2b2727");
                    row.find('.operate').unbind('click');
					row.find('.operate').html(getNowFormatDate());

					uploading[escape(fileName)] = undefined;
                    //
					// //控制进度条
					// var ele = $(".list .list-sound [filename='" + escape(fileName) + "']");
					// var eleProgress = ele.prev().children('i');
                    //
					// eleProgress.css('width',1000);
				},
				error: function (item) {
					var fileName = item.getFilename();
					var row = $("#fileList .file [filename='" + escape(fileName) + "']").parent();
					row.remove();
					uploading[escape(fileName)] = undefined;
				},
				aborted: function (item) {
					var fileName = item.getFilename();
					var row = $("#fileList .file [filename='" + escape(fileName) + "']").parent();
					row.remove();
					uploading[escape(fileName)] = undefined;
				}
			});


			var music_files_input_dom = $('.music_files_input');

			var filesName = '';
     		var sizes = '';
			$('#newfile_input').change(function () {
				var files = document.getElementById('newfile_input').files;
				for (var i = 0; i < files.length; ++i) {
					filesName += files[i].name + "|";
					sizes += files[i].size + "|";
					if(checkFileName(files[i].name)){
						alert(upConfigText.UNSUPPORTED_FILE_TYPE);
						music_files_input_dom.val("");
						continue;
					}else if(getFileSize(files[i].size) > (50*1024)){
						alert("文件"+files[i].name+"不能大于50MB。"+"当前文件大小"+formatFileSize(files[i].size));
						music_files_input_dom.val("");
						continue;
					}
					html5Uploader.add(files[i]);
				}
			});
		}

		return html5Uploader;
	}

	//上传途中取消
	function cancelUpload() {
		var uploader = getHtml5Uploader();
		var fileName = $(this).parent().find('.filename').attr('filename');
		if (fileName) {
			item = items[fileName];
			if (item) {
				uploader.abort(item);
				$(this).parent().remove();
			}
		}
	}

	/*页面加载绑定checkbox事件*/
	function switch_check_box(){

		/*
		 * 全选删除文件
		 */
		$("body").on("click",".list-top .check-box",function(){

			var $this=$("body .list-sound .check-box");
			var $self_check_box = $(this);		//全选按钮

			if($this.hasClass("on")){
				$this.removeClass("on");
				$self_check_box.removeClass("on");
				$this.closest(".file").removeClass("checked");
				$(".del-btn").addClass('undel');

			}else{
				$(".del-btn").removeClass('undel');
				$this.addClass("on");
				$self_check_box.addClass("on");
				$this.closest(".file").addClass("checked");
			}
		});

		/*
		 * 单选删除文件
		 */

		$("body").on("click",".list-sound .check-box",function(){
			var $this=$(this);
			if($this.hasClass("on")){
				$this.removeClass("on");
				$this.closest(".file").removeClass("checked");
				$(".del-btn").addClass('undel');

			}else{
				$(".del-btn").removeClass('undel');
				$this.addClass("on");
				$this.closest(".file").addClass("checked");
			}
		});
	}
	//给首页的那个图片绑定个click事件
	function upload_pic_button(){
		$("#upload_pic_button").click(function(){
			$("#newfile_input").trigger("click");
		});
	}


	function bind_del_button(){
		$(".del-btn").click(deleteAudio);
	}

	function getLocalTime(nS) {
		return new Date(parseInt(nS) * 1000).toLocaleString().replace(/年|月/g, "-").replace(/日/g, " ");
	}
	//init page reload data
	function page_realod_res(){
		if($("#res_json").val() != undefined){
			var res = JSON.parse(decodeURIComponent($("#res_json").val().replace(/\+/g, '%20')));

			var song_list_obj = $(".list-sound");

			for(var i=0;i<res.length;i++){
				$res_str =
					'<li class="item uploading" id="WU_FILE_2">'+
					'<div class="filename" filename="' + res[i].name + '">'+
					'<span class="check-box"></span>'+decodeURI(res[i].name).replace(/\+/g, " ")+
					'</div>'+
					'<div class="longtime">'+formatFileSize(res[i].size)+'</div>'+
					'<div class="operate" title="取消">'+format_times(parseInt(res[i].createtime))+'</div>'+
					'</li>';
				song_list_obj.append($res_str);
			}
		}else{
			//这里处理如果为空的话就显示那个红豆的图片
		}
	}
	//get format time to localTime.
	function getNowFormatDate() {
		var date = new Date();
		var seperator1 = "-";
		var seperator2 = ":";
		var month = date.getMonth() + 1;
		var strDate = date.getDate();
		if (month >= 1 && month <= 9) {
			month = "0" + month;
		}
		if (strDate >= 0 && strDate <= 9) {
			strDate = "0" + strDate;
		}
		var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate
			+ " " + date.getHours() + seperator2 + date.getMinutes()
			+ seperator2 + date.getSeconds();
		return currentdate;
	}

	function get_ios_res_list(){
		$.get('list',function(res){
			var str_res = res;
			if(str_res.code == 200){
				var song_list_obj = $(".list-sound");
				for(var i=0;i<str_res.data.length;i++){
					$res_str =
						'<li class="item uploading" id="WU_FILE_2">'+
						'<div class="filename" filename="' + str_res.data[i].name + '">'+
						'<span class="check-box"></span>'+decodeURI(str_res.data[i].name).replace(/\+/g, " ")+
						'</div>'+
						'<div class="longtime">'+str_res.data[i].size+'</div>'+
						'<div class="operate" title="取消">'+str_res.data[i].createtime+'</div>'+
						'</li>';
					song_list_obj.append($res_str);
				}
			}

		});
	}

	//页面初始化init
	$(document).ready(function() {
		bind_del_button();
		$.ajaxSetup({cache:false});		//禁用缓存
		page_realod_res();			//页面加载获取手机已有的音乐文件 android
		// get_ios_res_list();				//ios
		upload_pic_button();			//首页上传配乐图片绑定click事件
		getHtml5Uploader();				//初始化上传
	});
});
