/**
 * Created by guoyexuan on 2017/3/28.
 */
var upConfigText = {};

upConfigText.FILES_ON_DEVICE = '您设备上的文件列表';
upConfigText.FILENAME = '文件名';
upConfigText.FILE_SIZE = '大小';
upConfigText.FILE_OPER = '操作';
upConfigText.CONFIRM_DELETE_BOOK = '是否删除音频？';
upConfigText.DOWNLOAD_FILE = '下载文件';
upConfigText.DELETE_FILE = '删除文件';
upConfigText.USE_ONE_BROWSER = '无法上传文件，请勿使用多个浏览器窗口同时上传。';
upConfigText.UPLOAD_FAILED = '上传失败，请重新打开wifi音频上传服务并刷新此页重新上传。';
upConfigText.UNSUPPORTED_FILE_TYPE = '请选择MP3或M4A音频文件。';
upConfigText.FILE_IN_QUEUE = '文件已经在上传列队中。';
upConfigText.FILE_EXISTS = '文件已存在，请先删除再重新上传。';
upConfigText.YOU_CHOOSE = '您选择了';
upConfigText.CHOSEN_FILE_COUNT = '个文件，只能上传';
upConfigText.VALID_CHOSEN_FILE_COUNT = '个文件。\n请选择MP3或M4A文件，文件名不能重复。';
upConfigText.CANCEL = '取消';
upConfigText.CANNOT_CONNECT_SERVER = '无法连接wifi音频上传服务器，请重新打开wifi音频上传服务并刷新此页后重新上传。';
upConfigText.DRAG_TO_HERE = "拖拽到此处上传";
upConfigText.SELECT_BUTTON_LABLE1 = "选择文件";
upConfigText.SELECT_BUTTON_LABLE2 = "可同时上传多个文件";
upConfigText.SELECT_BUTTON_LABLE = "选择文件";
upConfigText.WIFI_AVAILABLE = "wifi连接已启用";
$(function() {
    if(!jQuery.handleError){
        jQuery.handleError = function( s, xhr, status, e )      {
            // If a local callback was specified, fire it
            if ( s.error ) {
                s.error.call( s.context || s, xhr, status, e );
            }

            // Fire the global callback
            if ( s.global ) {
                (s.context ? jQuery(s.context) : jQuery.event).trigger( "ajaxError", [xhr, s, e] );
            }
        };
    }
    var isDragOver = false;

    var files = [];
    var currentFileName;

    var uploadQueue = [];
    var currentQueueIndex = 0;
    var isUploading = false;
    var getProgressReties = 0;

    var html5Uploader = null;
    var items = {};
    var uploading = {};

    function showStatusMsg(msg,className){
        var msgTip=$('<div class="msgTip"></div>');
        msgTip.html('<span class="iocn '+className+'"></span>'+msg);
        $("body").append(msgTip);
    }
    function hideMsg(msg,className){
        var msgTip=$(".msgTip").remove();
    }

    function deleteAudio() {
        var fileObj=$(".file.checked"),
            fileObjLen=fileObj.length;
        if(fileObjLen<1){
            return alert("您还未勾选要删除的音频");
        }
        if (!confirm(upConfigText.CONFIRM_DELETE_BOOK)) {
            return;
        }
        showStatusMsg("正在删除",'loading');
        var fileNameArr=[];
        var uploader = getHtml5Uploader();
        for(var i=0;i<fileObjLen;i++){
            var fileName = unescape(fileObj.eq(i).find(".filename").attr("filename")) ||'';
            uploadingItem = uploading[fileName];
            if (uploadingItem) {
                uploader.abort(uploadingItem);
            }
            fileNameArr.push('"'+fileName+'"');
        }
        var deleteUrl = "/del";
        $.get(deleteUrl, {'filename':encodeURI('['+fileNameArr.toString()+']')}, function() {
            showStatusMsg("已删除",'success');
            setTimeout(function() {
                fileObj.remove();
            }, 300);
            setTimeout(function() {
                hideMsg();
            }, 2000);
        });
    }

    function resetFileNameByUpload(data,fileName,$el){
        for(var i=0;data.length;i++){
            if(data[i].name === fileName){
                $el.find(".filename").attr("filename",data[i].id);
                break;
            }
        }
    }

    function loadFileList() {
        var now = new Date();
        $(".delBtn").click(deleteAudio);
        var url = "/get_list?";
        $.getJSON(url + now.getTime(), function(data) {
            files = data;
            fillFilesContainer();
        });
        $("body").on("click",".file .check",function(){
            var $this=$(this);
            if($this.hasClass("on")){
                $this.removeClass("on");
                $this.closest(".file").removeClass("checked");
            }else{
                $this.addClass("on");
                $this.closest(".file").addClass("checked");
            }
        });
        $(".table_header .check").on("click",function(){
            var $this=$(this);
            if($this.hasClass("on")){
                $this.removeClass("on");
                $(".file").removeClass("checked");
                $(".file").find(".check").removeClass("on");
            }else{
                $this.addClass("on");
                $(".file").find(".check").addClass("on");
                $(".file").addClass("checked");
            }
        });
    }

    function fillFilesContainer() {
        var filesContainer = $("#fileList .files");
        for (var i = 0; i < files.length;i ++) {
            var row = $('<div class="file"></div>');
            var fileInfo = files[i];
            row.append('<div class="column filename" filename="' + escape(fileInfo.id) + '"><span class="check"></span>' + fileInfo.name +'</div>');
            row.append('<div class="column size">' + fileInfo.size + '</div>');
            row.append('<div class="column createTime" title="上传时间">'+fileInfo.date+'</div>');
            filesContainer.append(row);
        }
    }

    function getUploadProgress() {
        var time = new Date().getTime();
        var url = 'progress/' + encodeURI(currentFileName) + '?' + time;
        $.getJSON(url, function(data) {
            if (!data) {
                getProgressReties ++
                if (getProgressReties < 5) {
                    setTimeout(getUploadProgress, 500);
                    return;
                } else {
                    alert(upConfigText.USE_ONE_BROWSER);
                }
            }

            getProgressReties = 0;
            var ele = $("#fileList .file [filename='" + escape(data.fileName) + "']")
            var eleSize = ele.next()
            eleSize.text(data.size);
            var elePrecent = eleSize.next()
            elePrecent.text(Math.round(data.progress * 100) + "%");
            var eleProgress = ele.prev();
            eleProgress.animate({ width:Math.round(483 * data.progress) }, 280);

            if (data.progress < 1) {
                setTimeout(getUploadProgress, 300);
            } else {
                elePrecent.text('');
            }
        });
    }

    function startAjaxUpload() {
        if (isUploading || currentQueueIndex >= uploadQueue.length) {
            return;
        }

        isUploading = true;
        var eleFile = $(uploadQueue[currentQueueIndex]);
        var eleFileId = eleFile.attr('id');
        var fileName = eleFile.val();
        var arr = fileName.split("\\");
        fileName = arr[arr.length - 1];

        currentQueueIndex ++;

        var row = $("#fileList .file [filename='" + escape(fileName) + "']").parent();

        $.ajaxFileUpload({
            url:'files',
            secureuri:false,
            fileElementId:eleFileId,
            dataType: 'text',
            success: function (data, status) {
                window.location.reload();
                // var responseData = JSON.parse($(data).html());//这里data 是array型的api数据
                // resetFileNameByUpload(responseData,fileName,row);
                // row.removeClass('progress_wrapper');
                // row.find('.progress').remove();
                // row.find('.createTime').text(new Date().getFullYear()+'-'+new Date().getMonth()+'-'+new Date().getDate());
                //
                // isUploading = false;
                //
                // //IE的诡异情况
                // startAjaxUpload();
            },
            error: function (data, status, e) {
                isUploading = false;
                alert(upConfigText.UPLOAD_FAILED);
                row.remove();
                startAjaxUpload();
            }
        });

        currentFileName = fileName;
        //setTimeout(getUploadProgress, 300);
    }

    function checkFileName(fileName) {
        if (!fileName || !fileName.toLowerCase().match('(mp3|m4a)$')) {
            return upConfigText.UNSUPPORTED_FILE_TYPE;
        }

        var arr = fileName.split("\\");
        fileName = arr[arr.length - 1];

        var hasFile = false;
        var existFile = $("#fileList .file [filename='" + escape(fileName) + "']");
        if (existFile.length > 0) {
            $(this).val("");
            if (existFile.parent().hasClass('progress_wrapper')) {
                return upConfigText.FILE_IN_QUEUE;
            } else {
                return upConfigText.FILE_EXISTS;
            }
        }
        return null;
    }

    function uploadFiles(files) {
        var uploader = getHtml5Uploader();
        if (files.length == 1) {
            var msg = checkFileName(files[0].name || files[0].fileName);
            if (msg) {
                alert(msg);
                return;
            }
            uploader.add(files[0]);
            return;
        }

        var totalFiles = files.length;
        var actualFiles = 0;
        for (var i = 0; i < files.length; ++i) {
            if (!checkFileName(files[i].name || files[i].fileName)) {
                uploader.add(files[i]);
                actualFiles ++;
            }
        }
        if (totalFiles != actualFiles) {
            var msg = upConfigText.YOU_CHOOSE + totalFiles + upConfigText.CHOSEN_FILE_COUNT + actualFiles + upConfigText.VALID_CHOSEN_FILE_COUNT;
            alert(msg);
        }
    }

    function bindAjaxUpload(fileSelector) {
        $(fileSelector).unbind();
        $(fileSelector).change(function() {
            //TODO
            if (this.files) {
                uploadFiles(this.files);
                //优先使用HTML5上传方式
                return;
            }

            var fileName = $(this).val();

            var msg = checkFileName(fileName);
            if (msg) {
                alert(msg);
                return;
            }

            var arr = fileName.split("\\");
            fileName = arr[arr.length - 1];

            var row = $('<div class="file progress_wrapper"></div>');
            row.append('<div class="progress"></div>');
            row.append('<div class="column filename" filename="' + escape(fileName) + '"><span style="width: 14px; height: 14px; display: inline-block; margin: 0 10px 0 17px;"></span>' + fileName +'</div>');
            row.append('<div class="column size"> - </div>');
            //row.append('<div class="column precent">0%</div>');
            $("#fileList .files").prepend(row);

            uploadQueue.push(fileSelector);
            $(fileSelector).css({ top: '-9999px', left: '-9999px' });
            $('.file_upload_warper').append('<input type="file" name="newfile" value="" id="newfile_' + uploadQueue.length + '" class="file_upload" />');
            bindAjaxUpload('#newfile_' + uploadQueue.length);
            startAjaxUpload();
        });

        if (typeof(Worker) !== "undefined") {
            $(fileSelector)
                .mouseover(function() { $('#upload_button').removeClass('normal').addClass('pressed'); })
                .mouseout(function() { $('#upload_button').removeClass('pressed').addClass('normal'); })
                .mousedown(function() { $('#upload_button').removeClass('normal').addClass('pressed'); })
                .mouseup(function() { $('#upload_button').removeClass('pressed').addClass('normal'); });
        } else {
//			$(fileSelector)
//				.mouseover(function() { $('#upload_button').css('background-image', 'url("images/select_file1_rollover.jpg")'); })
//				.mouseout(function() { $('#upload_button').css('background-image', 'url("images/select_file1.jpg")'); })
//				.mousedown(function() { $('#upload_button').css('background-image', 'url("images/select_file1_pressed.jpg")'); })
//				.mouseup(function() { $('#upload_button').css('background-image', 'url("images/select_file1.jpg")'); });
        }
    }

    function formatFileSize(value) {
        var multiplyFactor = 0;
        var tokens = ["bytes","KB","MB","GB","TB"];

        while (value > 1024) {
            value /= 1024;
            multiplyFactor++;
        }

        return value.toFixed(1) + " " + tokens[multiplyFactor];
    }

    function cancelUpload() {
        var uploader = getHtml5Uploader();
        var fileName = $(this).parent().find('.filename').attr('filename');
        if (fileName) {
            item = items[fileName];
            if (item) {
                uploader.abort(item);
            }
        }
    }

    function getHtml5Uploader() {
        if (!html5Uploader) {
            html5Uploader = new bitcandies.FileUploader({
                url: 'files',
                maxconnections: 1,
                fieldname: 'newfile',
                enqueued: function (item) {
                    var fileName = item.getFilename();
                    items[escape(fileName)] = item;
                    uploading[escape(fileName)] = item;

                    var size = item.getSize();
                    var row = $('<div class="file progress_wrapper"></div>');
                    row.append('<div class="progress"></div>');
                    row.append('<div class="column filename" filename="' + escape(fileName) + '"><span class="check"></span>' + fileName +'</div>');
                    row.append('<div class="column size">' + formatFileSize(size) +'</div>');
                    row.append('<div class="column createTime">排队中…</div>');
                    //row.append('<div class="column createTime">'+new Date().getFullYear()+'-'+new Date().getMonth()+'-'+new Date().getDate()+'</div>');
                    $('<div class="column cancel" title="'+upConfigText.CANCEL+'">取消上传</div>')
                        .click(cancelUpload)
                        .appendTo(row);
                    $("#fileList .files").prepend(row);
                },
                progress: function (item, loaded, total) {
                    var fileName = item.getFilename();
                    var progress = loaded / total;

                    var ele = $("#fileList .file [filename='" + escape(fileName) + "']")
                    var elePrecent = ele.next().next();
                    elePrecent.text("上传中…");

                    var eleProgress = ele.prev();
                    eleProgress.width(483 * progress);
                },
                success: function (item,xhr) {
                    var fileName = item.getFilename();
                    var row = $("#fileList .file [filename='" + escape(fileName) + "']").parent();
                    var responseData = JSON.parse(xhr.response);
                    resetFileNameByUpload(responseData,fileName,row);
                    row.removeClass('progress_wrapper');
                    row.find('.progress').remove();
                    row.find('.createTime').text(new Date().getFullYear()+'-'+new Date().getMonth()+'-'+new Date().getDate());
                    row.find('.cancel').remove();
                    uploading[escape(fileName)] = undefined;
                },
                error: function (item) {
                    var fileName = item.getFilename();
                    var row = $("#fileList .file [filename='" + escape(fileName) + "']").parent();
                    row.remove();
                    uploading[escape(fileName)] = undefined;
                },
                aborted: function (item) {
                    var fileName = item.getFilename();
                    var row = $("#fileList .file [filename='" + escape(fileName) + "']").parent();
                    row.remove();
                    uploading[escape(fileName)] = undefined;
                }
            });
        }
        return html5Uploader;
    }

    function handleDragOver(evt) {
        evt.stopPropagation();
        evt.preventDefault();
        if (!isDragOver) {
            $(this).removeClass('normal').addClass('active');
            isDragOver = true;
        }
    }

    function handleDragLeave(evt) {
        evt.stopPropagation();
        evt.preventDefault();

        $(this).removeClass('active').addClass('normal');
        isDragOver = false;
    }

    function handleDrop(evt) {
        evt.stopPropagation();
        evt.preventDefault();
        var uploader = getHtml5Uploader();

        $(this).removeClass('active').addClass('normal');
        isDragOver = false;

        if (evt.dataTransfer && evt.dataTransfer.files) {
            uploadFiles(evt.dataTransfer.files);
        }
    }

    function dragUpload() {
        var dropArea = document.getElementById('drag_area');
        if (dropArea && dropArea.addEventListener) {
            dropArea.addEventListener('dragover', handleDragOver, false);
            dropArea.addEventListener('dragleave', handleDragLeave, false);
            dropArea.addEventListener('drop', handleDrop, false);
        }
    }

    function showHtml5View() {
        var dragAree = $('<div id="drag_area"></div)').addClass('normal').appendTo('#dragBox');
//      $('#upload_hint').empty();
//		$('<div>'+upConfigText.SELECT_YOUR_FILES+'<br />'+upConfigText.SUPPORTED_FILE_TYPES+'</div>')
//			.addClass('hint')
//			.insertAfter('#upload_button');

        var buttonLabels = $('<div class="button_lables"></div>').prependTo("#upload_button");
//      $('<div class="button_lable1"></div>').text(upConfigText.SELECT_BUTTON_LABLE1).appendTo(buttonLabels);
//      $('<div class="button_lable2"></div>').text(upConfigText.SELECT_BUTTON_LABLE2).appendTo(buttonLabels);

        //dragUpload();
    }

    function showHtml4View() {
        //$('#dragBox').append('<div class="wifi">' + upConfigText.WIFI_AVAILABLE + '</div>');
        //$('#upload_button').css('background-image', 'url("images/select_file1_rollover.jpg")');
//		$('#upload_hint').html(upConfigText.SELECT_YOUR_FILES+'<br />'+upConfigText.SUPPORTED_FILE_TYPES);
//      $('<div class="button_lable">' + upConfigText.SELECT_BUTTON_LABLE + '</div>').prependTo("#upload_button")
    }

    $(document).ready(function() {
        /*
         fillFilesContainer();
         loadFileList();
         bindAjaxUpload('#newfile_0');

         if (typeof(Worker) !== "undefined") {
         showHtml5View();
         } else {
         showHtml4View();
         }

         $(document).ajaxError(function(event, request, settings){
         alert(upConfigText.CANNOT_CONNECT_SERVER);
         hideMsg();
         $('.progress_wrapper, .progress').css( { 'background':'#f00' });
         });*/
    });
});
